/* catbat - concatenating batcher
 * vix 19mar91 [written]
 */

/* purpose: chdir to the directory named on the command line, find a numbered
 *	file which is not flocked and flock it, append stdin to it and close.
 *	if no unflocked files exist there, create a new one with the next
 *	highest number.
 */

#include <errno.h>
#include <stdio.h>
#include <sysexits.h>
#include <sys/file.h>
#include <sys/param.h>
#include <sys/types.h>

#define STDIN 0
#define FMODE 0777

main(argc, argv)
	int argc;
	char *argv[];
{
	extern void catbat();

	if (argc != 2) {
		(void) fprintf(stderr, "usage:  %s batchdir\n", argv[0]);
		(void) exit(EX_USAGE);
	}

	if (chdir(argv[1]) < 0) {
		(void) fprintf(stderr, "%s:  chdir ", argv[0]);
		(void) perror(argv[1]);
		(void) exit(EX_UNAVAILABLE);
	}

	(void) catbat();
	(void) exit(0);
}

void
catbat()
{
	int	f = 0, fd;
	char	n[MAXPATHLEN];
	u_char	buf[BUFSIZ];

	while (++f) {
		(void) sprintf(n, "%d", f);
		fd = open(n, O_WRONLY|O_APPEND|O_CREAT, FMODE);
		if (fd >= 0) {
			if (flock(fd, LOCK_EX|LOCK_NB) >= 0) {
				register x;

				while ((x = read(STDIN, buf, BUFSIZ)) > 0) {
					(void) write(fd, buf, x);
				}
				(void) flock(fd, LOCK_UN);
				return;
			}
			if (errno != EWOULDBLOCK) {
				(void) perror("flock");
				(void) exit(EX_OSERR);
			}
			(void) close(fd);
		} else {
			fprintf(stderr, "open(%s): %s\n", n, strerror(errno));
			(void) exit(EX_OSERR);
		}
	}
}
